/* BKFD.c
 * Build keyboard from def
 *
 * Written by David Allen <s2mdalle@titan.vcu.edu>
 * Http://opop.nols.com/
 * This file is released under the terms of the GNU General Public License.
 */

GtkWidget *build_keyboard_from_def(KEYBOARD *def)
{
     GtkWidget *handle = gtk_handle_box_new();
     GtkWidget *box    = gtk_vbox_new(FALSE, 0);
     GtkWidget *hbox   = gtk_hbox_new(FALSE, 0);
     GtkWidget *button;
     char label[1024];
     int caster;
     register int x, y;
     
     for(x=0; x<def->rows; x++)
     {
	  caster = def->row_syms[x][0];
	  if(isalpha(caster))
	  {
	       sprintf(label,"%s%c%s\n",
		       LEAD_SPACER, toupper(caster), TAIL_SPACER);
	  }
	  else
	  {
	       sprintf(label,"%s%s%s\n%s%s",
		       LEAD_SPACER, XKeysymToString(def->row_syms[1]),
		       TAIL_SPACER, LEAD_SPACER,
		       XKeysymToString(def->row_syms[0]));
	  }
	  
	  button = gtk_button_new_with_label(label);
	  gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 0);

     } /* End for */

     gtk_container_add(GTK_CONTAINER(handle), box);
     return(handle);
} /* End build_keyboard_from_def() */
