/* CALLBACKS.h
 *
 * This file is for use with GTKeyboard, and is released under the terms of
 * the GNU General Public License
 *
 * Written by David Allen <s2mdalle@titan.vcu.edu>
 * http://opop.nols.com/
 *
 * Prototypes for callbacks.c
 */

#define CALLBACKS_H

/* For callbacks.c */
int byebye				     (GtkWidget *emitter, gint foo);
void toggle_ask_save_on_exit                 (void);
void capslock_toggle                         (GtkWidget *w, gpointer data);
void alt_toggle                              (GtkWidget *w, gpointer data);
void alt_gr_toggle                           (GtkWidget *w, gpointer data);
void control_toggle                          (GtkWidget *w, gpointer data);
void toggle_double_data                      (void);
long sizeof_text_widget                      (GtkWidget *widget);
void shift_on                                (GtkWidget *w, gpointer data);
void status_report                           (GtkWidget *widget, 
					      gpointer data);
void status_logging_toggle                   (void);
void display_key                             (GtkWidget *widget, 
					      gpointer data);
void CutText                                 (GtkWidget *w, gpointer data);
void PasteText                               (GtkWidget *w, gpointer data);
void CopyText                                (GtkWidget *w, gpointer data);
void smack                                   (GtkWidget *w, gpointer data);
void save_output_text                        (GtkWidget *w, gpointer data);
void save_output_text_successful             (char *filename);
void save_output_text_error                  (char *error);
int delete_event                             (GtkWidget *foo, gpointer data);
void Showmenu                                (GtkWidget *w, gint input);
gint CloseApp                                (GtkWidget *widget, 
					      gpointer data);
void file_cancel_button                      (GtkWidget *w, 
					      GtkFileSelection *fs);
void gtkeyboard_signal_handler               (void);
void save_file_as                            (GtkWidget *emitter, 
					      gpointer data);
void gtkeyboard_grab_filename_save           (GtkWidget *emitter, 
					      gpointer data);
void remap_keyboard_really                   (GtkWidget *emitter, 
					      gpointer data);
