/* FILE_FOO.H
 * 
 * For use with GTKeyboard
 * written by David Allen s2mdalle@titan.vcu.edu
 * GPL, blah blah let's get on with it.
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <gtk/gtk.h>

#define SMALL_BUFFER    20
#define BIG_BUFFER      32

#define LINE_TOKENS                   3
#define	MAX_LINE_LENGTH	              128
#define	TOKEN_SIZE	              50
#define DEFAULT_RCFILE "# Default .gtkeyboardrc written by GTKeyboard\nset WORD_WRAP 0\nset STATUS_LOGGING ON\nset DISPLAY_TOOLBAR ON\n"

#define OPT_IS_GOOD(x)     (!(g_strcasecmp(x,"show")) ||\
                            !(g_strcasecmp(x,"on")) ||\
                            (atoi(x) == 1))
#define CHECK(var, const)  ((g_strcasecmp(var,const) == 0))

/* List of strings - GTKeyboard is really looking for these when it
 * reads the rcfiles.  These are the options it recognizes.  Case sensitive,
 * but of course.
 */
#define OPT_ASK_SAVE                 "ASK_SAVE_ON_EXIT"
#define OPT_REDIRECT_POLICY          "REDIRECT_POLICY"
#define OPT_XPOS                     "XPOS"
#define OPT_YPOS                     "YPOS"
#define OPT_ASK_REMAP_ON_EXIT        "ASK_REMAP_ON_EXIT"
#define OPT_EXTRA_FILES              "EXTRA_FILES"
#define OPT_WORD_WRAP                "WORD_WRAP"
#define OPT_SEND_TO_BOTH_WINDOWS     "SEND_DATA_TO_BOTH_WINDOWS"
#define OPT_PULLOFFS                 "PULLOFFS"
#define OPT_BORDERLESS               "BORDERLESS"
#define OPT_STATUS_LOGGING           "STATUS_LOGGING"
#define OPT_WORKING_FILE             "WORKING_FILE"
#define OPT_ALL_CAPS                 "ALL_CAPS"      /* Deprecated */
#define OPT_RAND_STRING_LENGTH       "RANDOM_STRLEN"
#define OPT_SMALL_WINDOWS            "SMALL_WINDOWS"
#define OPT_SHOW_MENU                "SHOW_MENU"
#define OPT_SHOW_TEXT                "SHOW_TEXT"
#define OPT_BUMP_AMOUNT              "BUMP_AMOUNT"
#define OPT_INFO_POPUPS              "INFO_POPUPS"
#define OPT_DISPLAY_TOOLBAR          "DISPLAY_TOOLBAR"
#define OPT_DISPLAY_ROW_BUTTONS      "DISPLAY_ROW_BUTTONS"
#define OPT_RANDOMIZE_XPMS           "RANDOMIZE_XPMS"
#define OPT_EYECANDY                 "EYECANDY"

/* Prototypes - creeping evil */
void FILE_readline                    (FILE *fp, char *buffer, 
				       const int maxlen);
int parse_rcfile                      (FILE *fp, char *filename);
char *expand_relative_pathname        (char *filename);
int gtkeyboard_load_shortcuts         (void);
void gtkeyboard_save_shortcuts        (GtkWidget *widget, gpointer data);
int setup_default_rcfile              (char *file);
