
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <sys/time.h>
#include <unistd.h>

#define NO_KEYCODE_PRESENT(x) (x->keycode == 0)
#define NO_KEYSYM_PRESENT(x)  (x->keysym == NoSymbol || \
			       x->keysym == (KeySym) NULL)

#define ERROR_CHECK_KEYCODE(XEV) if(XEV->keycode==0){\
                                 fprintf(Q,"IRXEVENT Warning: Keycode 0\n");\
                                 fflush(Q); return(0);}
#define ERROR_CHECK_KEYSYM(FOO)  if(FOO->keysym==NoSymbol){\
                              fprintf(Q,"IRXEVENT Warning: KeySymNoSymbol\n");\
                                 fflush(Q);}

#ifdef IRXEVENT_C
struct keymodlist_t {
     char *name;
     Mask mask;
};

static struct keymodlist_t keymodlist[]=
{
     {"SHIFT",   ShiftMask},
     {"CAPS",    LockMask},
     {"CTRL",    ControlMask},
     {"ALT",     Mod1Mask},{"META",    Mod1Mask},
     {"NUMLOCK", Mod2Mask},
     {"MOD3",    Mod3Mask},  /* I don't have a clue what key maps to this. */
     {"MOD4",    Mod4Mask},  /* I don't have a clue what key maps to this. */
     {"SCRLOCK", Mod5Mask},
     {NULL,0},
};

const char *key_delimiter ="-";
const char *active_window_name ="CurrentWindow";

char *progname;
Window root;
XEvent xev;
Window w;

#endif /* IRXEVENT_C */

/* fake_timestamp is static in irxevent.c */
Window find_window                    (Window top,char *name);
int make_key                          (char *keyname,XKeyEvent *xev);
void sendkey                          (char *keyname,Window w);
void keysym_sendkey                  (KeySym somesym, Window w);
void gtkeyboard_XEvent_common_setup   (XKeyEvent *xev);
KeySym character_to_keysym            (char i);

#ifdef IRXEVENT_C
static const char *zero_keycode = "
This key is not defined for your current keyboard mapping.
In order to make this key work in a foreign window, you must
remap your physical keyboard to this layout.  Choose
\"Remap Keyboard\" from the \"Misc\" menu to do this.
";
#endif
