/* SHORTCUTS.C
 * For use with GTKeyboard
 * written by David Allen
 * s2mdalle@titan.vcu.edu http://opop.nols.com/
 * 
 * This file is distributable under the terms of the GNU General Public License
 *
 * This is just a collection of shortcuts that will end up in a menu to make
 * typing faster
 *
 * The SC_ in the function names is for shortcut.
 *
 */

#include "master.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <errno.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>
#include <sys/time.h>

#ifdef MEM_DEBUGGING
#include "mem/memdebug.h"
#endif /* MEM_DEBUGGING */

#ifndef RAND_MAX
#define RAND_MAX 1
#endif

#define SHORTCUTS_C

/* Functions - makes heavy use of vanilla defined in html_mode.c */
/* These should be functions rather than macros so they can be included
 * in the item factories - otherwise not constant complaints from gcc
 */

void SC_report_length(void)
{
     char buffer[512];
     long size = sizeof_text_widget(GUI.main_output_text);
     long KILOBYTE = 1024;

     sprintf(buffer,"Your text area contains %ld characters.",size);
     annoying_popup(buffer);
     gtkeyboard_message(1,buffer,"\n");
     sprintf(buffer,"%ld characters is roughly %ld kilobytes\n",size,
	     (size / KILOBYTE));
     gtkeyboard_message(1,buffer,"\n");
     return;
} /* End SC_report_length */

void SC_timestamp(void)
{
     time_t now;
     struct tm *ptr;
     char sucka[40];
     char *ptr2;
     
     ptr2=&sucka[0];
     
     time(&now);
     ptr=localtime(&now);
     ptr2=asctime(ptr);
     
     chocolate("Inserting timestamp\n");

     vanilla(ptr2);
     vanilla("\n");
} /* End SC_timestamp */

void SC_rose(void)
{
     vanilla(" @}-'-,- ");
}

void SC_random_string(void)
{
     /* I have NO earthly idea why anybody would use this, but hey, it's 
      * your life, your memory, your CPU.  I'm just here for fun.
      */

     int x=0;
     char Achar;
     char *foobar;
     char *tmp;
     static char choices[]="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890-=!@#$%^&*()_+`~[]{}\\|,.<>/?";
     int RANDMAX = strlen(choices);
     char foo[1024];

     foobar = g_new0_(char, (options.RANDOM_STRING_CHARACTERS + 2));
     tmp = g_new0_(char, 3);

#ifndef HAVE_RAND
#error "You don't have the rand() system call???  And you expect me to compile???"
#endif /* HAVE_RAND */
     
     sprintf(tmp,"%c",choices[(rand() % RANDMAX)]);
     strcpy(foobar,tmp);

     sprintf(foo,"Inserting random string of length %d\n",
	     options.RANDOM_STRING_CHARACTERS);
     gtkeyboard_message(1,foo);

     for(x=1; x<options.RANDOM_STRING_CHARACTERS; x++)
     {
	  Achar = choices[(rand() % RANDMAX)];

	  sprintf(tmp,"%c",Achar);
	  strcat(foobar,tmp);
     } /* End for */

     vanilla(foobar);

     g_free_(tmp);
     g_free_(foobar);
} /* End sc_random_string */

void SC_angle(void)
{
     vanilla("<>");
     cursor_left();
}

void SC_double_angle(void)
{
     vanilla("<<>>");
     cursor_left();
     cursor_left();
}

void SC_paragraph(void)
{
     vanilla("\n\n\t");
}

void SC_hihat(void)
{
     vanilla("^^");
     cursor_left();
}

void SC_smiley(void)
{
     vanilla(":)");
}

void SC_winky(void)
{
     vanilla(";)");
}

void SC_quote(void)
{
     vanilla("\"\"");
     cursor_left();
}

void SC_single_quote(void)
{
     vanilla("''");
     cursor_left();
}

void SC_book_quote(void)
{
     vanilla("`'");
     cursor_left();
}

void SC_backquote(void)
{
     vanilla("``");
     cursor_left();
}

void SC_pseudo_underline(void)
{
     vanilla("__");
     cursor_left();
}

void SC_emphasize(void)
{
     vanilla("**");
     cursor_left();
}

void SC_surround(void)
{
     char *sur="--==";
     char *sur2="==--";
     int x;
     
     vanilla(sur);
     vanilla(sur2);
     for(x=0; x<strlen(sur2); x++)
	  cursor_left();
}

void SC_parens(void)
{
     vanilla("()");
     cursor_left();
}

/* EOF */
