/* TRULY_MISC.C
 * Written by David Allen
 * s2mdalle@titan.vcu.edu
 * http://opop.nols.com/
 *
 * Distributed under the GNU GPL.
 *
 * This is the place for all the things I couldn't figure out where to put. :)
 * Although it will probably get subcategorized Real Soon Now
 * Thanks to the GTK tutorial for this function xpm_to_widget (modified)
 */

#define TRULY_MISC_C
#include "master.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <errno.h>
#include <signal.h>
#include <ctype.h>
#include <X11/keysym.h>      /* Defines character sets */
#include <X11/keysymdef.h>
#include "xpm/splash.h"

/* extern GtkWidget *window; */

static char *foreign_character_guess(char input);

void flush_everything(void)
{
     fflush(Q);
     fflush(stdout);
     fflush(stderr);
} /* End flush_everything */

void HideAllButKeyboard(GtkWidget *emitter, gint input)
{
     hide_widget(NOWIDGET, HIDE_OUTPUT);
     hide_widget(NOWIDGET, HIDE_BOTTOM_ROW_BUTTONS);
     hide_widget(NOWIDGET, HIDE_TOOLBAR);
     hide_widget(NOWIDGET, HIDE_STATUS);
     hide_widget(NOWIDGET, HIDE_OUTPUT);
}

void ShowAll(GtkWidget *emitter, gint input)
{
     unhide_widget(NOWIDGET, SHOW_OUTPUT);
     unhide_widget(NOWIDGET, SHOW_BOTTOM_ROW_BUTTONS);
     unhide_widget(NOWIDGET, SHOW_TOOLBAR);
     unhide_widget(NOWIDGET, SHOW_STATUS);
     unhide_widget(NOWIDGET, SHOW_OUTPUT);
}

/* Hides various screen widgets */
void hide_widget(GtkWidget *emitter, gint input)
{
     switch(input)
     {
     case HIDE_OUTPUT:
	  if(!options.SHOW_ALL_WINDOWS)
	       chocolate("Can't Hide/Show window - SHOW_ALL_WINDOWS off\n");
	  else
	       gtk_widget_hide(GUI.master_text);
	  break;
     case HIDE_BOTTOM_ROW_BUTTONS:
	  gtk_widget_hide(GUI.bottom_row_buttons);
	  break;
     case HIDE_MENUS:
	  /* gtk_widget_hide(GUI.item_factory); */
	  options.SHOW_MENU = OFF;
	  /* make_item_factory(); */
	  break;
     case HIDE_TOOLBAR:
	  gtk_widget_hide(GUI.toolbar);
	  break;
     case HIDE_STATUS:
	  gtk_widget_hide(GUI.s_table); /* Hide the status window */
	  break;
     case HIDE_KEYBOARD:
	  gtk_widget_hide(GUI.KEYBOARD); /* Hide the keyboard */
	  break;
     default:
	  break;
     } /* End switch */
} /* End hide_widget */

/* Shows various widgets */
void unhide_widget(GtkWidget *emitter, gint input)
{
     switch(input)
     {
     case SHOW_OUTPUT:
	  if(!options.SHOW_ALL_WINDOWS)
	       chocolate("Can't show/hide output - SHOW_ALL_WINDOWS off.\n");
	  else
	       gtk_widget_show(GUI.master_text);
	  break;
     case SHOW_TOOLBAR:
	  gtk_widget_show(GUI.toolbar);
	  break;
     case SHOW_MENUS:
	  /* gtk_widget_show(GUI.item_factory); */
	  options.SHOW_MENU = ON;
	  make_item_factory();
	  break;
     case SHOW_BOTTOM_ROW_BUTTONS:
	  gtk_widget_show(GUI.bottom_row_buttons);
	  break;
     case SHOW_STATUS:
	  gtk_widget_show(GUI.s_table);  /* Show the status menu table */
	  break;
     case SHOW_KEYBOARD:
	  gtk_widget_show(GUI.KEYBOARD);
	  break;
     default:
	  break;
     } /* End switch */
} /* End unhide_widget */

GtkWidget *xpm_to_widget(GtkWidget *foo, gchar **xpm_data)
{
     /* GtkWidget is the storage type for widgets */
     GtkWidget *pixmapwid;
     GdkPixmap *pixmap;
     GdkBitmap *mask;
     GtkStyle *style;

     style = gtk_widget_get_style(window);

     /* In order for this to not create a warning, window has to be a
      * gtk_realize_widget (realized) widget
      */
     pixmap = gdk_pixmap_create_from_xpm_d(window->window,  &mask,
					   &style->bg[GTK_STATE_NORMAL],
					   (gchar **)xpm_data );
     
     /* a pixmap widget to contain the pixmap */
     pixmapwid = gtk_pixmap_new(pixmap, mask);
     gtk_widget_show(pixmapwid);
     
     return(pixmapwid);
} /* End xpm_to_widget */

GtkWidget *widget_from_xpm_file(const char *filename)
{
     GdkPixmap *pixmap;
     GdkBitmap *bitmap;
     GtkWidget *widget;

     pixmap = gdk_pixmap_create_from_xpm(window->window, &bitmap, 
					 (GdkColor *)NULL, filename);
     widget = gtk_pixmap_new(pixmap, bitmap);
     return(widget);
} /* End widget_from_xpm_file */

void splash(void)
{
     GtkWidget *window, *button;
     GtkWidget *foo = (GtkWidget *)NULL;

     window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

     /* Give the xpm a small border */
     gtk_widget_set_usize(window, 310, 119);

     gtk_window_set_title(GTK_WINDOW(window), "GTKeyboard");

     gtk_signal_connect(GTK_OBJECT(window), "delete_event",
			GTK_SIGNAL_FUNC(gtk_widget_destroy), window);

     foo = xpm_to_widget(window, (gchar **)splash_xpm);

     button = gtk_button_new();
     gtk_container_add(GTK_CONTAINER(button), foo);
     gtk_signal_connect(GTK_OBJECT(button), "clicked",
			GTK_SIGNAL_FUNC(smack), window);

     gtk_container_add(GTK_CONTAINER(window), button);

     gtk_widget_show_all(window);
} /* End splash */

#ifndef USE_REMOTE_CONTROL
/* Creates a packed table with choices based on compass directions
 * which the user can click on to send the main window to any of the
 * possible locations.
 */
void gtkeyboard_positioning(GtkWidget *emitter, gpointer data)
{
     GtkWidget *foo = gtk_dialog_new();
     GtkWidget *ok = create_ok_button(GTK_SIGNAL_FUNC(smack), foo);
     GtkWidget *cancel = create_cancel_button(foo);
     GSList *group = NULL;
     GtkWidget *radio_buttons[9];
     GtkWidget *table = gtk_table_new((gint)3, (gint)3, TRUE);
     register int x=0;

     int passers[] = { UL_CORNER, T_CENTER, UR_CORNER,
		       L_CENTER,  WIN_CENTER, R_CENTER,
		       BL_CORNER, B_CENTER, BR_CORNER              };
     char *labels[] = { "Northwest", "North",    "Northeast",
			"West",      "Centered", "East",
			"Southwest", "South",    "Southeast"        };

     for(x=0; x<9; x++)
     {
	  radio_buttons[x] = gtk_radio_button_new_with_label(group, 
							     labels[x]);
	  group = gtk_radio_button_group(GTK_RADIO_BUTTON(radio_buttons[x]));
	  gtk_signal_connect(GTK_OBJECT(radio_buttons[x]), "clicked",
			     GTK_SIGNAL_FUNC(move_window), 
			     (gpointer)passers[x]);
     } /* End for */

     gtk_table_attach(GTK_TABLE(table), radio_buttons[0], 0, 1, 0, 1,
		      GTK_EXPAND | GTK_SHRINK | GTK_FILL,
		      GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
     gtk_table_attach(GTK_TABLE(table), radio_buttons[1], 1, 2, 0, 1,
		      GTK_EXPAND | GTK_SHRINK | GTK_FILL,
		      GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
     gtk_table_attach(GTK_TABLE(table), radio_buttons[2], 2, 3, 0, 1,
		      GTK_EXPAND | GTK_SHRINK | GTK_FILL,
		      GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
     gtk_table_attach(GTK_TABLE(table), radio_buttons[3], 0, 1, 1, 2,
		      GTK_EXPAND | GTK_SHRINK | GTK_FILL,
		      GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
     gtk_table_attach(GTK_TABLE(table), radio_buttons[4], 1, 2, 1, 2,
		      GTK_EXPAND | GTK_SHRINK | GTK_FILL,
		      GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
     gtk_table_attach(GTK_TABLE(table), radio_buttons[5], 2, 3, 1, 2,
		      GTK_EXPAND | GTK_SHRINK | GTK_FILL,
		      GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
     gtk_table_attach(GTK_TABLE(table), radio_buttons[6], 0, 1, 2, 3,
		      GTK_EXPAND | GTK_SHRINK | GTK_FILL,
		      GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
     gtk_table_attach(GTK_TABLE(table), radio_buttons[7], 1, 2, 2, 3,
		      GTK_EXPAND | GTK_SHRINK | GTK_FILL,
		      GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
     gtk_table_attach(GTK_TABLE(table), radio_buttons[8], 2, 3, 2, 3,
		      GTK_EXPAND | GTK_SHRINK | GTK_FILL,
		      GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);

     gtk_box_pack_start(GTK_BOX(GTK_DIALOG(foo)->vbox), table,
			FALSE, FALSE, 0);
     gtk_box_pack_start(GTK_BOX(GTK_DIALOG(foo)->action_area), ok,
			FALSE, FALSE, 0);
     gtk_box_pack_start(GTK_BOX(GTK_DIALOG(foo)->action_area), cancel,
			FALSE, FALSE, 0);

     gtk_widget_show_all(foo);
} /* End gtkeyboard_positioning */
#endif /* #ifndef USE_REMOTE_CONTROL */

void not_done_yet(void)
{
     GtkWidget *foo, *kill, *label;

     foo = gtk_dialog_new();
     kill = create_ok_button(GTK_SIGNAL_FUNC(smack), foo);
     label = gtk_button_new_with_label(
	  "Sorry, this function isn't implemented yet");

     gtk_box_pack_start(GTK_BOX(GTK_DIALOG(foo)->vbox),
			label, TRUE, TRUE, 0);
     gtk_box_pack_start(GTK_BOX(GTK_DIALOG(foo)->action_area),
			kill, TRUE, TRUE, 0);
     
     gtk_widget_show_all(foo);
} /* End not_done_yet */

gint final_check(void)
{
     /* Make a dialog instead of homegrown */
     GtkWidget *finalcheck;
     GtkWidget *yes, *no, *label;

     if(options.ASK_REMAP_ON_EXIT)
	  remap_at_exit_dialog((GtkWidget *)NULL, (gpointer)NULL);

     finalcheck = gtk_dialog_new();
     yes = create_ok_button(GTK_SIGNAL_FUNC(CloseApp), finalcheck);
     no  = create_cancel_button(finalcheck);
     label = gtk_label_new("Are you sure you want to quit?");

     /* Pack them into the dialog box */
     gtk_box_pack_start(GTK_BOX(GTK_DIALOG(finalcheck)->vbox),
			label, TRUE, TRUE, 0);
     gtk_box_pack_start(GTK_BOX(GTK_DIALOG(finalcheck)->action_area),
			yes, TRUE, TRUE, 0);
     gtk_box_pack_start(GTK_BOX(GTK_DIALOG(finalcheck)->action_area),
			no, TRUE, TRUE, 0);

     gtk_window_set_position(GTK_WINDOW(finalcheck), GTK_WIN_POS_CENTER);

     gtk_widget_show_all(finalcheck);
     return(TRUE);
} /* End final_check */

void grab_a_window(GtkWidget *w, gpointer data)
{
     int frame = 0;

     redirect_to = Select_Window_Args(fargc, fargv);

     /* Set other back to null so we have to look for another window before
      * we insert keys into that window 
      */
     options.other = (Window)NULL;

     chocolate("\n\nCHOOSE THE WINDOW TO REDIRECT TO WITH THE POINTER\n\n");

     /* Get the user to use the pointer to select a window */
     redirect_to = Select_Window(GDK_DISPLAY());

     if (redirect_to && !frame)
     {
	  Window root;
	  int dummyi;
	  unsigned int dummy;

	  if (XGetGeometry(GDK_DISPLAY(), redirect_to, &root, &dummyi, &dummyi,
			    &dummy, &dummy, &dummy, &dummy) && 
	      redirect_to != root)
	  {
	       redirect_to = XmuClientWindow(GDK_DISPLAY(), redirect_to);
	  } /* End if */
     } /* End if */

     /* Display_window_id will automatically reallocate 
      * options.redirect_window_name  and so on.
      */
     (void *)Display_Window_Id(redirect_to, True);
     
     options.redirect_window = RootWindow(GDK_DISPLAY(),DefaultScreen(GDK_DISPLAY()));
     
     /* Everything should be set up */

     /* Note:  If they chose an invalid window name, then
      * options.redirect_window_name will be NULL and chocolate will 
      * cause a segfault if given that.  (gtk_text_insert problem?)
      */

     if(options.redirect_window_name)
     {
          options.other = find_window(options.redirect_window,
			    	      options.redirect_window_name);
	  /* Valid window name */
	  gtkeyboard_message(3,"Ok, now we've got \"",
			     options.redirect_window_name,
			     "\" as the window we're pointing at.\n");
     }
     else
     {
	  /* Invalid window.  Make the user keep picking till he gets
	   * something we can address.
	   */
	  gtkeyboard_error(3,"\nI'm sorry, but that window has no name.\n",
			   "Did you choose the root window to redirect to?\n",
			   "OUTPUT WINDOW NOT CHOSEN-PLEASE CHOOSE AGAIN\n\n");
	  
	  annoying_popup("Error:  Window not chosen - see status.");
			   
     } /* End else */
     return;
} /* End grab_a_window */

void send_redirect_a_keysym(KeySym input)
{
     Window window;
     int revert_to;

     if(!options.other || options.other == (Window)NULL)
     {
	  /* SEND_TO_BOTH_WINDOWS was probably set and there wasn't
	   * a redirect window to send to.  Let's save the time involved
	   * with doing all this string crap and just jump out here.
	   */
	  return;
     }

     if(options.other)
     {
         /* send to window user picked */
	 keysym_sendkey(input, options.other);
     } /* End if */
     else
     {
	  /* default to just send the event to whatever window has the input
	   * focus 
	   */
	  chocolate("WARNING: Getting input focus and sending it there.\n");
	  XGetInputFocus (GDK_DISPLAY(), &window, &revert_to);
	  keysym_sendkey(input, window);
     } /* End else */
} /* End send_redirect_a_keysym() */

void switch_X_char(char letter, char *string)
{
     /* Let's make some groupings, and then have if's down from there...if
      * we can cut out a lot of possibilities, we can speed things up
      * hopefully.  Branch by defined types out of ctype.h
      */
     char *ptr;

     ptr = XKeysymToString((KeySym)letter);

     if(ptr)
     {
	  /* Got it.  Now wasn't that easy? :) */
	  strcat(string,ptr);
	  return;
     } /* End if */

     guess_at_keysym(letter,string);
     return;
} /* End switch_X_char */

/* Having to run this function sucks.  Period. */
void guess_at_keysym(char letter,char *string)
{
     /* char *yahoo="~!@#$%^&*?()_+{}<>\":"; */
     char tmp[4];

     sprintf(tmp,"%c",letter);

     if(letter=='\t')
	  strcat(string,"Tab");
     else if(letter=='\n' || letter=='\r')
	  strcat(string,"Return");
     else if(letter==' ')
	  strcat(string,"space");
     else 
     {
	  switch(letter)
	  {
	  case '\b':  strcat(string,"BackSpace");    break;
	  case '=':   strcat(string,"equal");        break;
	  case '>':   strcat(string,"greater");      break;
	  case '<':   strcat(string,"less");         break;
	  case ':':   strcat(string,"colon");        break;
	  case ';':   strcat(string,"semicolon");    break;
	  case '?':   strcat(string,"question");     break;
	  case '~':   strcat(string,"asciitilde");   break;
	  case '@':   strcat(string,"at");           break;
	  case '\\':  strcat(string,"backslash");    break;
	  case '_':   strcat(string,"underscore");   break;
	  case '`':   strcat(string,"quoteleft");    break;
	  case '{':   strcat(string,"braceleft");    break;
	  case '}':   strcat(string,"braceright");   break;
	  case '[':   strcat(string,"bracketleft");  break;
	  case ']':   strcat(string,"bracketright"); break;
	  case '-':   strcat(string,"minus");        break;
	  case '|':   strcat(string,"brokenbar");    break;
	  case '.':   strcat(string,"period");       break;
	  case '(':   strcat(string,"parenleft");    break;
	  case ')':   strcat(string,"parenright");   break;
	  case '/':   strcat(string,"slash");        break;
	  case '+':   strcat(string,"plus");         break;
	  case '*':   strcat(string,"asterisk");     break;
	  case '&':   strcat(string,"ampersand");    break;
	  case '%':   strcat(string,"percent");      break;
	  case '"':   strcat(string,"quotedbl");     break;
	  case ',':   strcat(string,"comma");        break;
	  case '#':   strcat(string,"numbersign");   break;
	  case '$':   strcat(string,"dollar");       break;
	  case '\'':  strcat(string,"apostrophe");   break;
	  case '!':   strcat(string,"exclam");       break;
	  default:
	       /* Get the name of the foreign character and append here */
	       strcat(string,foreign_character_guess(letter));
	       break;
	  } /* End switch */
     } /* End else */
} /* End guess_at_keysym */

char *foreign_character_guess(char input)
{
     char buf[16];
     char *ptr = &buf[0];

     /* Characters marked with a "redo" are things that I'm not sure about.
      * they're probably wrong, and need to be looked over.
      *
      * ALL CODES ARE OCTAL NOT DECIMAL OR HEX
      */

     switch(input)
     {
     case '`':     return("grave");

     case '\241':  return("exclamdown");
     case '\242':  return("cent");
     case '\243':  return("dollar");
     case '\244':  return("sterling");
     case '\245':  return("yen");
     case '\246':  return("block");            /* REDO */
     case '\247':  return("section");
	  /* Empty table 247->250 */
     case '\250':  return("quotedbl");
     case '\251':  return("C");                /* REDO */
	  /* 252 -> 255 TODO */
     case '\254':  return("block");            /* REDO */
     case '\256':  return("R");                /* REDO */
     case '\257':  return("block");            /* REDO */
	  /* Empty table 252->260 */
     case '\260':  return("degree");
     case '\261':  return("plusminus");
     case '\262':  return("twosuperior");
	  /* case '\262':  return("Escape"); */
     case '\265':  return("mu");
     case '\266':  return("paragraph");
     case '\272':  return("Escape");
     case '\274':  return("onequarter");
     case '\275':  return("onehalf");
     case '\277':  return("questiondown");
     case '\304':  return("Adiaeresis");
     case '\306':  return("AE");
     case '\307':  return("Ccedilla");
     case '\312':  return("E");                /* REDO */
     case '\313':  return("E");                /* REDO */
     case '\314':  return("I");                /* REDO */
     case '\315':  return("I");                /* REDO */
     case '\316':  return("I");                /* REDO */
     case '\317':  return("Idiaeresis");
	  /* Empty table 317->320 */
     case '\320':  return("block");
     case '\321':  return("Ntilde");
     case '\326':  return("Odiaeresis");
     case '\327':  return("x");
	  /* Empty table 328->330 */
     case '\330':  return("SOMETHING");        /* REDO */
     case '\331':  return("ugrave");
     case '\332':  return("U");                /* REDO */
     case '\333':  return("U");                /* REDO */
     case '\334':  return("Udiaeresis");
     case '\337':  return("ssharp");
     case '\340':  return("agrave");
     case '\341':  return("aacute");
     case '\342':  return("acircumflex");
     case '\343':  return("a");
     case '\344':  return("adiaeresis");
     case '\346':  return("ae");
     case '\347':  return("ccedilla");
	  /* Empty table 347 -> 350 */
     case '\350':  return("egrave");
     case '\351':  return("eacute");
     case '\352':  return("ecircumflex");
     case '\353':  return("ediaeresis");
     case '\354':  return("igrave");
     case '\355':  return("iacute");
     case '\356':  return("icircumflex");
     case '\357':  return("idiaeresis");
	  /* Empty table 357 -> 360 */
     case '\360':  return("block");
     case '\361':  return("ntilde");
     case '\362':  return("ograve");
     case '\363':  return("oacute");
     case '\364':  return("ocircumflex");
     case '\365':  return("o");               /* REDO */
     case '\366':  return("odiaeresis");
     case '\367':  return("division");
	  /* Empty table 368->370 */
     case '\371':  return("ugrave");
     case '\372':  return("uacute");
     case '\373':  return("ucircumflex");
     case '\374':  return("udiaeresis");
     case '\375':  return("y");
     case '\376':  return("block");
     case '\377':  return("ydiaeresis");
	  /* No default case - use sprintf below */
	  /* default:      return("a"); */
     } /* End switch */

     /* A relatively safe return sometimes */
     sprintf(buf,"%c",(int)input);
     return(ptr);
} /* End foreign_character_guess */

void ignore_window(void)
{
     if(options.redirect_window_name)
     {
	  chocolate("Ignoring old window ");
	  chocolate(options.redirect_window_name);
	  chocolate("\n");
	  g_free_(options.redirect_window_name);
	  options.redirect_window_name = NULL;
     }
     else
     {
	  gtkeyboard_error(1, "No redirect window to ignore.\n");
     } /* End else */

     options.other = (Window)NULL;
     options.redirect_window_name = NULL;  /* Gets nullified for later tests */
} /* End ignore_window */
